/*
 * listerine.c - listen on stream port, keeps fresh breath all day
 * <sw3wn@poc.csoft.net>
 */
#include "listerine.h"

int sock, msgsock;
int outtype=0;
int gport=0;


void
doquit()
{
  close(sock);
  close(msgsock);
  exit(0);
}

void
dotrap()
{
  signal(SIGHUP,&doquit);
  signal(SIGINT,&doquit);
  signal(SIGTERM,&doquit);
  signal(SIGPIPE,&doquit);
  signal(SIGKILL,&doquit);
}

/* output (slow) */
void
dooutput(c, offset)
     const char c;
     unsigned long int offset;
{
  switch(outtype) {
  case OT_STRING:
    printf("%c",c);
    break;
  case OT_HEX:
    printf("[%lx] %x\n",offset,c);
    break;
  case OT_HEXASCII:
    printf("[%lx] %i %c\n",offset,c,c);
    break;
  }
}

/*
 * terribly long main function -
 * sorry i made this in a few minutes
 */
void
main(argc, argv)
     int argc;
     char** argv;
{
  int rval=0, tsock=-1;
  struct sockaddr_in addr;
  char buf[BUF_SIZE];
  unsigned char eofm=EOF;
  unsigned long int ib=0, ibb=0;
  int c;

  /* parse command-line arguments */
  if(argc<=1) {
    printf("
listerine <sw3wn@poc.csoft.net>
usage: %s [options]
%s\n",argv[0],HELP);
    exit(0);
  }

  while( (c=getopt(argc,argv, "p:shx")) != EOF ) {
    switch(c) {
    case 'p':
      gport=atoi(optarg);
      break;
    case 's':
      outtype=OT_STRING;
      break;
    case 'h':
      outtype=OT_HEX;
      break;
    case 'x':
      outtype=OT_HEXASCII;
      break;
    }
  }

  /* create inet domain stream socket */
  if( (sock=socket(AF_INET,SOCK_STREAM,0)) < 0 ) {
    perror("socket()");
    exit(1);
  }

  /* bind it, start to listen for connections */
  inet_aton(WHERE_TOBIND,&addr.sin_addr);
  addr.sin_family=AF_INET;
  addr.sin_port=htons(gport);
  if( bind(sock,(struct sockaddr*)&addr,sizeof(addr)) < 0 ) {
    perror("bind()");
    exit(1);
  }

  listen(sock, 2);
  dotrap();

  /* main lewp */
  while(1) {
    if( (tsock=accept(sock,0,0)) < 0 ) {
      perror("accept()");
      exit(1);
    } else {
      while(1) {
	msgsock=tsock;
	bzero(buf,sizeof(buf));
	
	while( (rval=recv(msgsock,buf,BUF_SIZE,0)) > 0 ) {
	  if(!rval)
	    doquit();
	  else {
	    ibb=0;

	    while( (buf[ibb]!='\0') &&
		   (ibb<=BUF_SIZE) ) {
	      dooutput(buf[ibb],ib);
	      ib++; ibb++;
	    }
	  }
	}
	send(msgsock,&eofm,1,0); /* i'm pretty fly for a white guy */
      }
    }
    printf("\n\a");
    doquit();
  }
}
